import os
import numpy as np
import pandas as pd
import time
import json
import pathlib
import torch
import torch.nn as nn
import torch.optim as optim
import matplotlib.pyplot as plt
from torch.utils.data import DataLoader
from sklearn.model_selection import StratifiedShuffleSplit
from numpy import loadtxt, savetxt
from sklearn import metrics, model_selection
import math 
from train_utils import *
from models import *
from metrics import *
from train import Training 
import seaborn as sns

plt.rcParams.update(plt.rcParamsDefault)
#%matplotlib inline

plt.style.use('seaborn')
    
curr_dir_path = str(pathlib.Path().absolute())
cwd = os.getcwd() 
save_dir_path = '/logs/'
gpu_num = 0 
cuda_available = torch.cuda.is_available()
if cuda_available:
    torch.cuda.set_device(gpu_num)
    
    data_dir = '' ##dir containing the data 
    
            
    print("seq length", pos_seq_encoded_chr19.shape)
    pos_seq_encoded_chr19 = pos_seq_encoded_chr19.astype(np.float32)
    pos_seq_encoded_chr19 = torch.from_numpy(pos_seq_encoded_chr19[0:153,:])
    
 
    disease = loadtxt(data_dir + 'disease_repeats/' + 'disease_1_45_2420_twos.csv', delimiter=',')
    print(disease)    
def run():
    
    test_dataset = 0
    bunch = 0
    
    length = 8-
    width = 4*length #seq of 80 nucl one hot enc
    num_windows = math.ceil(end/width)
    
    print(num_windows)
    #pos_seq_encoded_chr19 = loadtxt('chr21.fa_test_negative_80_spikes_stpos20.csv', delimiter=',')
    cwd = 'C:/Users/30697/Desktop/Deep-Learning-DNA-Sequences-master/Code/split/correct_split/VAE_gumble_softmax-master/data/' 
    pos_seq_encoded_chr19 = loadtxt(cwd + 'heatmaps/' + 'chr1.fa_positive_320_heatmaps.csv', delimiter=',')
    
    print("seq length", pos_seq_encoded_chr19.shape)
    pos_seq_encoded_chr19 = pos_seq_encoded_chr19.astype(np.float32)
    pos_seq_encoded_chr19 = torch.from_numpy(pos_seq_encoded_chr19)
    
   
    cwd = 'C:/Users/30697/Desktop/Deep-Learning-DNA-Sequences-master/Code/split/correct_split/VAE_gumble_softmax-master/data/codis/'  

    disease = loadtxt(cwd + 'disease_loci_19.csv', delimiter=',')
    print("shape", disease.shape)
    
    if test_dataset == 0:
        disease = pos_seq_encoded_chr19
        end = pos_seq_encoded_chr19.shape[1]
        num_windows = math.ceil(end/width)
        print("num windows", num_windows)
        
    size = disease.shape[0]
    
    if bunch != 0:
       ## 4*length
        zer = torch.zeros(size, num_windows*width-disease.shape[1])
        print("adding zeros at the end", len(zer))
        disease = np.concatenate((disease, zer), axis = 1)
        print("new shape", disease.shape)
    elif test_dataset == 0:
        zer = torch.zeros(size, width)
        disease = np.concatenate((disease, zer), axis = 1)
    print("shape", disease.shape)
    disease = disease.astype(np.float32)
    disease = torch.from_numpy(disease)
    whole_seq = torch.reshape(disease, (1, -1))
    print(whole_seq.shape)
    whole_seq = whole_seq.squeeze(0)
    
    num = 2
    data = 0*whole_seq
    
    print(data.shape)
    
    ## Load model 
    curr_dir_path = str(pathlib.Path().absolute())
    save_dir_path = 'logs/'    
    json_dir = "cnn_before_60_gap_10.pt"   
    with open(curr_dir_path + "/config.json", encoding='utf-8', errors='ignore') as json_data:
            config = json.load(json_data, strict=False)
    

    #load trained model 
    device =  torch.device('cuda' if torch.cuda.is_available() else 'cpu')
    model = CNN_hp_tuning(device, no_conv=config['MODEL']['Conv no'], no_filters=config['MODEL']['Filter no'], 
                                       filter_size=config['MODEL']['Filter size'], stride=config['MODEL']['Conv stride'], 
                                       pool_size=config['MODEL']['Pool size'], pool_stride=config['MODEL']['Pool stride'],
                                       dense_output=config['MODEL']['FC layer output'], no_dense_layers = config['MODEL']['No FC layers'],
                                       dropout=config['MODEL']['dropout'], input_length=length)
    model.load_state_dict(torch.load(json_dir, map_location=torch.device('cpu')))
    print(model)
    obj = Training(config, save_dir_path)
    obj.model = model
     
    zer = torch.zeros(width)
    whole_seq =  torch.cat([whole_seq, zer]) ### needed to be able to slide over the last window
    
    spikes = np.zeros(int(data.shape[0]/4))
    binarized = np.zeros(int(data.shape[0]/4))
    print(whole_seq.shape)
    
    for i in range(0, data.shape[0]-width, 4):
        
        seq = whole_seq[i:i+width] 
        ##check if there is a 2 in the array - 2's have been added in the end of the sequences to make them all the same length (helps with processing them all together)         
        mask = np.isin(seq, 2)
        test = seq[mask]
        if (len(test) >0):
            spikes[int(i/4)] = -1
        else:
            seq = seq.unsqueeze(0)
           # print(i)
            seq = seq.reshape(-1, length, 4)
            seq = np.transpose(seq, (0, 2, 1))

            obj.model.eval()
            output = obj.model.forward(seq)  
            spikes[int(i/4)] = output
            
        if spikes[int(i/4)]>0.6:
            binarized[int(i/4)] = 1 
        else:
            binarized[int(i/4)] = 0
            
    print("spikes shape", spikes.shape)   

    
            
            
    if test_dataset == 0:        
        spikes = spikes.reshape(-1, (num_windows+1)*length)
        binarized = binarized.reshape(-1, (num_windows+1)*length)
        spikes_avg = np.mean(spikes, axis=0)
        binarized_avg = np.mean(binarized, axis=0)
        
        spikes = spikes[:,0:(num_windows-1)*length]
        binarized = binarized[:,0:(num_windows-1)*length]
        
        spikes_avg = np.mean(spikes, axis=0)
        binarized_avg = np.mean(binarized, axis=0)
       
        
                
        plt.plot(range(-40,140), binarized_avg)
        print(binarized_avg)
        print(spikes_avg)
        plt.xlabel('Position', fontsize = 11) # x-axis label with fontsize 15
        plt.ylabel('Average model output', fontsize = 11)
        plt.yticks(rotation=0)
        
        plt.savefig('average_before.png', bbox_inches='tight') 
        plt.savefig('average_before.eps', bbox_inches='tight') 
        plt.show()
    
    elif (test_dataset == 1 and bunch==1) :        
        spikes = spikes.reshape(-1, num_windows*length)
        binarized = binarized.reshape(-1, num_windows*length)
        spikes_avg = np.mean(spikes, axis=0)
        binarized_avg = np.mean(binarized, axis=0)
        
        spikes = spikes[:,0:(num_windows-1)*length]
        binarized = binarized[:,0:(num_windows-1)*length]
        spikes_avg = spikes_avg[0:(num_windows-1)*length]
        binarized_avg = binarized_avg[0:(num_windows-1)*length]
        
        plt.plot(range((num_windows-1)*length), spikes_avg)
        plt.plot(range((num_windows-1)*length), binarized_avg)
        plt.show()    
    else:

        print(spikes.shape)
        plt.plot(rrange(-40,140), spikes)
        plt.xlabel('Position', fontsize = 11) # x-axis label with fontsize 15
        plt.ylabel('Average model output', fontsize = 11)
        plt.yticks(rotation=0)
        plt.show()
        fig = ax.get_figure()
        fig.savefig('average_before.png', bbox_inches='tight') 
        fig.savefig('average_before.eps', bbox_inches='tight') 
        
        binarized_mean = np.expand_dims(binarized_mean, 0)
        spikes = np.expand_dims(spikes, 0)
    
    print("spikes dim", spikes.shape)
    spikes_mean = np.zeros((spikes.shape[0], spikes.shape[1]))
    binarized_mean = np.zeros((spikes.shape[0], spikes.shape[1]))
    for y in range(spikes.shape[0]):
        for i in range(1, spikes.shape[1] - 1):
            spikes_mean[y, i] = np.mean(spikes[y, i-1:i+1])
            if spikes_mean[y, i]>0.5:
                binarized_mean[y, i] = 1 
            else:
                binarized_mean[y, i] = 0
            
    
    
    ##filter out noise
    for k in range(1):
        for y in range(spikes.shape[0]):
            for i in range(1, spikes.shape[1] - 1):
                mean = (binarized_mean[y, i-1] + binarized_mean[y, i] + binarized_mean[y, i+1])/3
                if binarized_mean[y, i] == 1:
                    binarized_mean[y, i] = mean
               # print(np.mean(binarized_mean[y, i-1:i+1]))
                if binarized_mean[y, i]>0.5:
                    binarized_mean[y, i] = 1 
                else:
                    binarized_mean[y, i] = 0
                    
    #sns.cubehelix_palette(start=.5, rot=-.5, as_cmap=True)
    
    #sns.light_palette("seagreen", as_cmap=True)
    
    
    df = pd.DataFrame(spikes_mean, columns=range(-40,140))
    ax = sns.heatmap(df, vmin=0.2, vmax=1,  xticklabels=10)
    plt.xlabel('Position', fontsize = 11) # x-axis label with fontsize 15
    plt.ylabel('Sample num.', fontsize = 11)
    plt.yticks(rotation=0)
    
    ax.axes.yaxis.set_visible(False)
    fig = ax.get_figure()
    fig.savefig('heatmap_before_gap10_neg.png', bbox_inches='tight') 
    fig.savefig('heatmap_before_gap10_neg.eps', bbox_inches='tight') 
    plt.show()
    #plt.savefig('heatmap.png', format='png')
    ##Jaccard coefficient 
    if test_dataset == 1:
        
        #first 1 
        first = np.argmax(binarized_mean, axis=1)
        print(np.argmax(binarized_mean, axis=1))
        #last 1
        last = []
        for i in range(binarized_mean.shape[0]):
            #print(np.nonzero(binarized_mean[i,:]))
           # print(i)
            non_zero = np.nonzero(binarized_mean[i,:])
         #   print(non_zero[0])
            if non_zero[0] != []:
                maxi = np.amax(non_zero)
            else:
                maxi = -1
            last = np.append(last, maxi) 

       # print(last)
        jaccard = []
        print(first)
        for i in range(binarized_mean.shape[0]):
            union =  max(last[i]-length, last_true[i]-length) - min(first[i], 20) 
            intersection = min(last[i]-length, last_true[i]-length) - max(first[i], 20) 
         #   print(union, intersection)
            jac = intersection/union
            jaccard = np.append(jaccard, max(jac,0))
        print("Jaccard ", jaccard)
        print("Jaccard>0.5 ", len(jaccard[jaccard>0.5]))
        print("Jaccard>0.7 ", len(jaccard[jaccard>0.7]))
        print("Jaccard mean", jaccard.mean())
        ###save date and plot spikes with actual repeats
   
if __name__ == "__main__":

    run()